DECLARE SUB getitifyawantta (A$)     'subroutine to load the GIF picture.

DEFINT A-Z
SCREEN 13           'change to graphics screen mode 13
CLS

DIM gb(18, 13)      'peg board layout array
DIM gbc(18, 13)

GOSUB SETUP

fil$ = "plinko.gif"
getitifyawantta fil$                  'call sub to load graphic game board

LOCATE 1, 1
LOCATE , 20: PRINT " <- PLINKO.GIF     "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " All the circles   "
LOCATE , 20: PRINT " represent ball and"
LOCATE , 20: PRINT " peg locations.    "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " The ball locations"
LOCATE , 20: PRINT " all have separate "
LOCATE , 20: PRINT " color attributes. "
LOCATE , 20: PRINT " They will be      "
LOCATE , 20: PRINT " changed to the    "
LOCATE , 20: PRINT " same color as the "
LOCATE , 20: PRINT " background.       "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " The peg locations "
LOCATE , 20: PRINT " all have the same "
LOCATE , 20: PRINT " color attribute.  "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " The ball locations"
LOCATE , 20: PRINT " will be turned on "
LOCATE , 20: PRINT " and off as the    "
LOCATE , 20: PRINT " ball drops.       "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " Press spacebar.   ";

zz$ = INPUT$(1)   'pause until any key is pressed.

LOCATE 1, 1
LOCATE , 20: PRINT " Use the arrow keys"
LOCATE , 20: PRINT " to place the ball."
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " Press the spacebar"
LOCATE , 20: PRINT " to release ball.  "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " Press Esc to quit."
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT " It is like a board"
LOCATE , 20: PRINT " of lights.  You   "
LOCATE , 20: PRINT " turn off attribute"
LOCATE , 20: PRINT " then turn on      "
LOCATE , 20: PRINT " another to get the"
LOCATE , 20: PRINT " effect of a ball  "
LOCATE , 20: PRINT " falling.          "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   "
LOCATE , 20: PRINT "                   ";

GOSUB PLAY.BOARD      'setup game board arrays, black out color attrs 32-149

start:

RANDOMIZE TIMER
bx = 1: by = 7                   ' ball location in game board array
PALETTE gbc(bx, by), white&      ' show the ball by changing that ball
                                 ' location's attribute to the color white.

top:
 k$ = INKEY$
 IF k$ = CHR$(27) THEN GOTO FINI     'quite when escape is pressed

 IF bx = 1 AND k$ <> "" THEN         'the ball is released
    IF k$ = CHR$(32) THEN
       PALETTE gbc(bx, by), 0        'change ball location to the color black
       bx = bx + 1
       SOUND 300, .1
    END IF

    IF k$ = CHR$(0) + CHR$(75) THEN      'move ball left
       PALETTE gbc(bx, by), 0
       by = by - 2
       IF by < 1 THEN by = 1
    END IF
   
    IF k$ = CHR$(0) + CHR$(77) THEN      'move ball right
       PALETTE gbc(bx, by), 0
       by = by + 2
       IF by > 13 THEN by = 13
    END IF
 END IF

 PALETTE gbc(bx, by), white&             'turn on new ball location. white.

 IF bx = 1 THEN GOTO top   'ball is waiting to be dropped, goto beginning

 'ball falling delay
 bdelay = bdelay + 1
 IF bdelay > 500 THEN bdelay = 0 ELSE GOTO top

 'ball is falling,   turn ball off. black.
 PALETTE gbc(bx, by), 0

 IF bx = 18 THEN     'ball reached bottom.  flash cup ball landed in.
    FOR j = 1 TO 100
      PALETTE gbc(bx, by), 0
      FOR jj& = 1 TO 2000: NEXT jj&
      PALETTE gbc(bx, by), white&
      FOR jj& = 1 TO 2000: NEXT jj&
    NEXT j
    PALETTE gbc(bx, by), 0
    GOTO start
 END IF

 IF gb(bx + 1, by) = 0 THEN    'no peg below ball, move ball down one.
    bx = bx + 1
    PALETTE gbc(bx, by), white&
    IF bx < 18 THEN IF gb(bx + 1, by) = 2 THEN SOUND 300, .1
    GOTO top
 END IF

 IF gb(bx + 1, by) = 2 THEN   'peg below ball, move ball left/right then down.
    bx = bx + 1
    IF INT(RND * 2) + 1 = 1 THEN by = by - 1 ELSE by = by + 1
    IF by < 1 THEN by = 2
    IF by > 13 THEN by = 12
    PALETTE gbc(bx, by), white&
    GOTO top
 END IF


GOTO top


'=========================================================================

REM PALETTE 1, 4144959     'white

'=========================================================================
SETUP:
 white& = 4144959

RETURN

'=========================================================================
FINI:
 CLOSE
 END

'=========================================================================
PLAY.BOARD:
 RESTORE PLAY.BOARD
 attr = 31
 FOR x = 1 TO 18
   FOR y = 1 TO 13
     READ gb(x, y)
     gbc(x, y) = 0
     IF gb(x, y) = 0 THEN
        attr = attr + 1
        gbc(x, y) = attr
        PALETTE attr, 0
     END IF
   NEXT y
 NEXT x
RETURN

 'data files represent where the pegs are on the board
 '
 '0=BALL LOCATIONS   'all locations on the board the ball can go.
 '2=PEGS             'the peg which causes the ball to fall left or right.
 '3=UNUSED
 DATA 0,3,0,3,0,3,0,3,0,3,0,3,0
 DATA 0,3,0,3,0,3,0,3,0,3,0,3,0
 DATA 2,0,2,0,2,0,2,0,2,0,2,0,2
 DATA 3,0,3,0,3,0,3,0,3,0,3,0,3
 DATA 0,2,0,2,0,2,0,2,0,2,0,2,0
 DATA 0,3,0,3,0,3,0,3,0,3,0,3,0
 DATA 2,0,2,0,2,0,2,0,2,0,2,0,2
 DATA 3,0,3,0,3,0,3,0,3,0,3,0,3
 DATA 0,2,0,2,0,2,0,2,0,2,0,2,0
 DATA 0,3,0,3,0,3,0,3,0,3,0,3,0
 DATA 2,0,2,0,2,0,2,0,2,0,2,0,2
 DATA 3,0,3,0,3,0,3,0,3,0,3,0,3
 DATA 0,2,0,2,0,2,0,2,0,2,0,2,0
 DATA 0,3,0,3,0,3,0,3,0,3,0,3,0
 DATA 2,0,2,0,2,0,2,0,2,0,2,0,2
 DATA 3,0,3,0,3,0,3,0,3,0,3,0,3
 DATA 0,2,0,2,0,2,0,2,0,2,0,2,0
 DATA 0,3,0,3,0,3,0,3,0,3,0,3,0

SUB getitifyawantta (A$)
SHARED Xstart, Ystart, xlength, ylength

'I don't know who wrote the GIF decoder, but its the first one
'I've tried that actually worked.

 DIM Prefix(4095), Suffix(4095), OutStack(4095), ShiftOut(8)
 
 'The following line is for the QB environment(slow).
 DIM Ybase AS LONG, Powersof2(11) AS LONG, WorkCode AS LONG
 
 'For more speed, unremark the next line and remark the one above,
 'before you compile... (Change back when inside the environment.)
 'DIM Ybase AS INTEGER, Powersof2(11) AS INTEGER, WorkCode AS INTEGER
 
 FOR A = 0 TO 7
   ShiftOut(8 - A) = 2 ^ A
 NEXT A
 
 FOR A = 0 TO 11
   Powersof2(A) = 2 ^ A
 NEXT A
 
 OPEN A$ FOR BINARY AS #1
  A$ = "      "
  GET #1, , A$
  IF A$ <> "GIF87a" THEN PRINT "Not a GIF87a file.": END

 GET #1, , TotalX
 GET #1, , TotalY
 GOSUB GetByte

 NumColors = 2 ^ ((A AND 7) + 1)
 NoPalette = (A AND 128) = 0

 GOSUB GetByte
 Background = A

 GOSUB GetByte
 IF A <> 0 THEN PRINT "Bad screen descriptor.": END

 IF NoPalette = 0 THEN P$ = SPACE$(NumColors * 3): GET #1, , P$
 DO
     GOSUB GetByte
     IF A = 44 THEN
         EXIT DO
     ELSEIF A <> 33 THEN
         PRINT "Unknown extension type.": END
     END IF
     GOSUB GetByte
     DO: GOSUB GetByte: A$ = SPACE$(A): GET #1, , A$: LOOP UNTIL A = 0
 LOOP

 GET #1, , Xstart
 GET #1, , Ystart
 GET #1, , xlength
 GET #1, , ylength
 XEnd = Xstart + xlength
 YEnd = Ystart + ylength

 GOSUB GetByte
 IF A AND 128 THEN PRINT "Can't handle local colormaps.": END
 Interlaced = A AND 64
 PassNumber = 0
 PassStep = 8
 GOSUB GetByte
 ClearCode = 2 ^ A
 EOSCode = ClearCode + 1
 FirstCode = ClearCode + 2: NextCode = FirstCode
 StartCodeSize = A + 1: CodeSize = StartCodeSize
 StartMaxCode = 2 ^ (A + 1) - 1: MaxCode = StartMaxCode
 BitsIn = 0: BlockSize = 0: BlockPointer = 1
 x = Xstart: y = Ystart: Ybase = y * 320&

 SCREEN 13: DEF SEG = &HA000
 IF NoPalette = 0 THEN
     OUT &H3C7, 0: OUT &H3C8, 0
     FOR A = 1 TO NumColors * 3: OUT &H3C9, ASC(MID$(P$, A, 1)) \ 4: NEXT
 END IF

 LINE (0, 0)-(319, 199), Background, BF

 DO
     GOSUB GetCode
     IF Code <> EOSCode THEN
         IF Code = ClearCode THEN
             NextCode = FirstCode
             CodeSize = StartCodeSize
             MaxCode = StartMaxCode
             GOSUB GetCode
             CurCode = Code: LastCode = Code: LastPixel = Code
             IF x < 320 THEN POKE x + Ybase, LastPixel
             x = x + 1: IF x = XEnd THEN GOSUB NextScanLine
         ELSE
             CurCode = Code: StackPointer = 0
             IF Code > NextCode THEN EXIT DO 'bad GIF if this happens
             IF Code = NextCode THEN
                 CurCode = LastCode
                 OutStack(StackPointer) = LastPixel
                 StackPointer = StackPointer + 1
             END IF
 
             DO WHILE CurCode >= FirstCode
                 OutStack(StackPointer) = Suffix(CurCode)
                 StackPointer = StackPointer + 1
                 CurCode = Prefix(CurCode)
             LOOP
 
             LastPixel = CurCode
             IF x < 320 THEN POKE x + Ybase, LastPixel
             x = x + 1: IF x = XEnd THEN GOSUB NextScanLine
 
             FOR A = StackPointer - 1 TO 0 STEP -1
                 IF x < 320 THEN POKE x + Ybase, OutStack(A)
                 x = x + 1: IF x = XEnd THEN GOSUB NextScanLine
             NEXT
 
             IF NextCode < 4096 THEN
                 Prefix(NextCode) = LastCode
                 Suffix(NextCode) = LastPixel
                 NextCode = NextCode + 1
                 IF NextCode > MaxCode AND CodeSize < 12 THEN
                     CodeSize = CodeSize + 1
                     MaxCode = MaxCode * 2 + 1
                 END IF
             END IF
             LastCode = Code
         END IF
     END IF
 LOOP UNTIL DoneFlag OR Code = EOSCode
 GOTO tt

'------------------------------------------------------------------------
GetByte:
  A$ = " "
  GET #1, , A$
  A = ASC(A$)
RETURN

'------------------------------------------------------------------------
NextScanLine:
     IF Interlaced THEN
         y = y + PassStep
         IF y >= YEnd THEN
             PassNumber = PassNumber + 1
             SELECT CASE PassNumber
             CASE 1: y = 4: PassStep = 8
             CASE 2: y = 2: PassStep = 4
             CASE 3: y = 1: PassStep = 2
             END SELECT
         END IF
     ELSE
         y = y + 1
     END IF
     x = Xstart: Ybase = y * 320&: DoneFlag = y > 199
RETURN

'------------------------------------------------------------------------
GetCode:
     IF BitsIn = 0 THEN GOSUB ReadBufferedByte: LastChar = A: BitsIn = 8
     WorkCode = LastChar \ ShiftOut(BitsIn)
     DO WHILE CodeSize > BitsIn
         GOSUB ReadBufferedByte: LastChar = A
         WorkCode = WorkCode OR LastChar * Powersof2(BitsIn)
         BitsIn = BitsIn + 8
     LOOP
     BitsIn = BitsIn - CodeSize
     Code = WorkCode AND MaxCode
RETURN

'------------------------------------------------------------------------
ReadBufferedByte:
     IF BlockPointer > BlockSize THEN
         GOSUB GetByte: BlockSize = A
         A$ = SPACE$(BlockSize): GET #1, , A$
         BlockPointer = 1
     END IF
     A = ASC(MID$(A$, BlockPointer, 1)): BlockPointer = BlockPointer + 1
RETURN

'------------------------------------------------------------------------
tt:
 CLOSE #1
 END SUB

